/**
 *
 * @file tg_token.hh
 * @author Lasse Lehtonen
 *
 *
 */

/*
 * Copyright 2010 Tampere University of Technology
 * 
 *  This file is part of Transaction Generator.
 *
 *  Transaction Generator is free software: you can redistribute it and/or modify
 *  it under the terms of the Lesser GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Transaction Generator is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  Lesser GNU General Public License for more details.
 *
 *  You should have received a copy of the Lesser GNU General Public License
 *  along with Transaction Generator.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * $Id: tg_token.hh 1399 2010-08-26 13:56:45Z lehton87 $
 *
 */

#ifndef SCTG_TG_TOKEN_HH
#define SCTG_TG_TOKEN_HH

#include <systemc>

struct tgToken
{
   unsigned long int source;      // port ID
   unsigned long int destination; // port ID
   unsigned long int size;        // bytes
   unsigned long int id;
   bool              isEvent;     // True if this came from event
   sc_core::sc_time  timeSent;
   sc_core::sc_time  timeReceived;

   tgToken()
   {
      source = 0;
      destination = 0;
      size = 0;
      id = 0;
      isEvent = false;
   }
};

#endif


// Local Variables:
// mode: c++
// c-file-style: "ellemtel"
// c-basic-offset: 3
// End:
